using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SerialTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        /// <summary>
        /// [ڑ]{^NbNꍇ̏B
        /// YCOM|[gp\ȏꍇ͐ڑsB
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCOMOpen_Click(object sender, EventArgs e)
        {
            try
            {
                if (serialPort1.IsOpen)
                { 
                    MessageBox.Show(this.textBox1.Text + " ͂łɊJĂ܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                else
                {
                    // |[gԍ=this.textBox1.Text, 115200bps/N81/n[hEFAt[/UTF8/s=CR
                    this.serialPort1.PortName = this.textBox1.Text;
                    this.serialPort1.BaudRate = 115200;
                    this.serialPort1.Parity   = System.IO.Ports.Parity.None;
                    this.serialPort1.DataBits = 8;
                    this.serialPort1.StopBits = System.IO.Ports.StopBits.One;
                    this.serialPort1.Handshake = System.IO.Ports.Handshake.RequestToSend;
                    this.serialPort1.Encoding = Encoding.UTF8;
                    this.serialPort1.NewLine = "\r";
                    serialPort1.Open();

                    this.buttonCOMOpen.Enabled = false;
                    this.buttonCOMClose.Enabled = true;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        /// <summary>
        /// [ؒf]{^NbNꍇ̏B
        /// ݊JĂCOM|[gؒfB
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCOMClose_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.Close();
                this.buttonCOMOpen.Enabled = true;
                this.buttonCOMClose.Enabled = false;
            }
        }

        /// <summary>
        /// [M]{^NbNꍇ̏B
        /// ̓tH[̕𑗐MB̓tH[ɂ͕s̕
        /// \t\B
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSend_Click(object sender, EventArgs e)
        {
            SendString();
        }

        /// <summary>
        /// ̓tH[EnterL[ꍇ̏B
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox2_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                this.textBox2.Text += "\r\n";
                SendString();
            }
        }

        /// <summary>
        /// MBsR[h͐ڑɐݒ肵̂ɕύXB
        /// </summary>
        /// <param name="text">M</param>
        private void SendString(string text)
        {
            try
            {
                this.serialPort1.Write(text);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private void SendString()
        {
            string str = this.textBox2.Text;
            str = str.Replace("\r\n", serialPort1.NewLine);
            SendString(str);

            this.textBox2.Text = "";
            this.textBox2.Focus();
        }

        /// <summary>
        /// MB{\bhFormƂ͕ʃXbhŏ邽߁A
        /// Form̒l̏sꍇɂdelegate𗘗pForm̃XbhŏB
        /// </summary>
        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            // M̎擾
            string receivedData;
            try{
                receivedData = this.serialPort1.ReadExisting();
                receivedData = receivedData.Replace(this.serialPort1.NewLine, "\r\n");
            }catch(Exception ex){
                receivedData = ex.Message;
            }

            // richTextBox̃Xbh AddRecievedData\bh̃|C^nāA
            // Mǉ
            AddRecievedDataDelegate add = new AddRecievedDataDelegate(AddRecievedData);
            this.richTextBox1.Invoke(add, receivedData);
        }
        private delegate void AddRecievedDataDelegate(string data);
        private void AddRecievedData(string data)
        {
            this.richTextBox1.Text += data;

            // \̍Ō܂ŃXN[
            this.richTextBox1.Focus();
            this.richTextBox1.SelectionStart = this.richTextBox1.Text.Length;
            this.richTextBox1.ScrollToCaret();

            // ̓tH[փtH[JXړ
            this.textBox2.Focus();
        }
    }
}